
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"
#include <unistd.h>

#define YesWindows 0


#if YesWindows 
 #include <windows.h>
#else
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <termios.h>
 #define BAUDRATE B9600
#endif

#define DEBUG 0
#define SONIDO 1

	const int SCREEN_WIDTH = 640; 
	const int SCREEN_HEIGHT = 480; 
	const int SCREEN_BPP = 32;

	//The surfaces that will be used 
	SDL_Surface *message = NULL; 
	SDL_Surface *background = NULL; 
	SDL_Surface *screen = NULL;
	SDL_Surface *dots = NULL;

	SDL_Event event;

	TTF_Font *font = NULL;

	SDL_Color textColor = { 25, 25, 25 };


	char VARI[100];
	struct BUTTON {
		int numero;		//1-boton 2-luzRoja 3-luzVerde 4-entradas
		char *nombre;
		unsigned char estado;
		int x;
		int y;
		int w;
		int h;
	};

#define MAXBOTONES 20
#define MAXLUCES 20
#define MAXENTRADAS 4
	struct  BUTTON nboton[MAXBOTONES];
	struct  BUTTON nluz[MAXLUCES];
	struct  BUTTON nentrada[MAXENTRADAS];

#if YesWindows 
	char MODEMDEVICEdefault[]= "COM3";
	HANDLE hSerial;
// DCB dcbSerial;
    DCB dcbSerialParams;
    COMMTIMEOUTS time_out;
#else
	char MODEMDEVICEdefault[]= "/dev/ttyUSB0";
	struct termios newtermios;
	int fd;
#endif

char *MODEMDEVICE;

char Binput[100];
char Binput2[10];
int  ContadorI;
char *CEntrada;

Mix_Chunk *sonido;

int TICK_INTERVAL=2000;

//_________________________________________________


Uint32 TimeLeft(void)
{
    static Uint32 next_time = 0;
    Uint32 now;

    now = SDL_GetTicks();
    if ( next_time <= now ) {
        next_time = now+TICK_INTERVAL;
        return(0);
    }
    return(next_time-now);
}

int Inirs232()
{
#if YesWindows  	
 //____________Programacion serie Windows__________________________
 
 
         hSerial = CreateFile(MODEMDEVICE,GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING,0, NULL);

         if(hSerial==INVALID_HANDLE_VALUE)
           {
             if(GetLastError()==ERROR_FILE_NOT_FOUND)
              {
               printf("PUERTO NO EXISTE !! \n"); 
               return 0;
              }
           }
           else
           {
//            dcbSerial.DCBlength=sizeof(dcbSerialParams);
            if (!GetCommState(hSerial, &dcbSerialParams))
               {
                printf("Error get Status!!\n");
                return 0;
               }                           
            dcbSerialParams.BaudRate=CBR_9600;
            dcbSerialParams.ByteSize=8;
            dcbSerialParams.StopBits=ONESTOPBIT;
            dcbSerialParams.Parity=NOPARITY;
            if (!SetCommState (hSerial, &dcbSerialParams))
              {
               CloseHandle(hSerial);
               printf("Error get Status2!!\n");
               return 0;
              }           
            time_out.ReadIntervalTimeout = 20; 
            time_out.ReadTotalTimeoutMultiplier = 2; 
            time_out.ReadTotalTimeoutConstant = 50; 
            time_out.WriteTotalTimeoutMultiplier = 2; 
            time_out.WriteTotalTimeoutConstant = 50;  
            if (SetCommTimeouts(hSerial, &time_out)==0)
               printf("Error SetCommTimeouts \n"); 
           }
           WriteSerie(hSerial,"SETA43\n",1);
#else
//_________Programacion Linux________________________

	
	fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY );
   	if (fd <0) 
		{
		 printf("Error puerto de comunicaciones\n");
		 exit(-1);  
		}	
  newtermios.c_cflag= BAUDRATE | CS8 | CLOCAL | CREAD;
  newtermios.c_iflag=IGNPAR;
  newtermios.c_oflag=0;
  newtermios.c_lflag=0;
  newtermios.c_cc[VMIN]=1;
  newtermios.c_cc[VTIME]=0;

  cfsetospeed(&newtermios,BAUDRATE);
  cfsetispeed(&newtermios,BAUDRATE);
 
  if (tcflush(fd,TCIFLUSH)==-1) return -1;
  if (tcflush(fd,TCOFLUSH)==-1) return -1;
  if (tcsetattr(fd,TCSANOW,&newtermios)==-1) return -1;  

  //Hace que el puerto serie no espere	
  fcntl(fd, F_SETFL, O_NDELAY );	
#endif

	return 0;
}

SDL_Surface *load_image( char *filename )
{ 
	SDL_Surface *temp,*ima;

	temp  =IMG_Load(filename);
	if (temp == NULL){
		printf("Error al cargar %s\n", filename);
		exit(EXIT_FAILURE);
	}			 
		ima = SDL_DisplayFormat(temp);
		SDL_FreeSurface( temp );

        if( ima != NULL )
        {
            Uint32 colorkey = SDL_MapRGB( ima->format, 0, 0xFF, 0xFF );
            SDL_SetColorKey( ima, SDL_SRCCOLORKEY, colorkey );
			if(DEBUG)printf("ok al cargar %s\n", filename);
        }
	
	return ima; 
}



void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, NULL, destination, &offset );
	}
void apply_surfaceB( int x, int y, SDL_Surface* source, SDL_Surface* destination,SDL_Rect* clip )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, clip, destination, &offset );
	}

int init()
{

    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )  return 0;
 //   screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
    screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );

    if( screen == NULL )   return 0;
	
    if(TTF_Init()==-1) 
		{
    	 printf("TTF_Init: %s\n", TTF_GetError());
   		 return 0;
		}
	//Initialize SDL_mixer 
	if(SONIDO)if( Mix_OpenAudio( 22050, MIX_DEFAULT_FORMAT, 2, 4096 ) == -1 )
		{
		 printf("Error SDL Mixer_Init:");
		 return 0;
		}

    SDL_WM_SetCaption( "Control entradas Arduino", NULL );

    return 1;
}

int load_files()
{
    background = load_image( "aserie2.jpg" );
    if( background == NULL )  return 0;
	dots = load_image( "aserie1.png" );
    if( dots == NULL )  return 0;

    font = TTF_OpenFont( "seta.ttf", 20 );
	if( font == NULL )
    {
		printf("Error cargando Font\n");
        return 0;
    }
	// Cargamos sonido
	if(SONIDO)sonido = Mix_LoadWAV("pit.wav");
 	if(SONIDO)if ( sonido == NULL )
		{
		 printf("No pude cargar sonido: %s\n", Mix_GetError());
     	 exit(1);
 		}

  return 1;
}

void clean_up()
{
	if(SONIDO)Mix_FreeChunk(sonido);
    SDL_FreeSurface( background );
	SDL_FreeSurface( dots );
    SDL_Quit();
}

void Paintbutton(int x,int y,int w,int h,char *texto,unsigned char tipo)
{
  int w1,h1;
 SDL_Rect clip[ 1 ];
 SDL_Surface *message;
	if(tipo==0)
	{
		clip[ 0 ].x = 0;
	    clip[ 0 ].y = 0;
    	clip[ 0 ].w = 89;
    	clip[ 0 ].h = 25;
	}
	else
	{
		clip[ 0 ].x = 89;
	    clip[ 0 ].y = 0;
    	clip[ 0 ].w = 89;
    	clip[ 0 ].h = 25;		
	}
 	apply_surfaceB( x, y, dots, screen, &clip[ 0 ] );
	message = TTF_RenderText_Solid( font,texto, textColor );
	if(TTF_SizeText(font,texto,&w1,&h1))
		{
			printf("Error tamao texto");
		} 
		else
		{
			w1=w1/2;
			w1=45-w1;
			if(w1<0)w1=0;
		}	
	apply_surface( x+w1, y+2, message, screen );
}	


void PaintBoton(int numero,int modo)
{
  Paintbutton(nboton[numero].x,nboton[numero].y,nboton[numero].w,nboton[numero].h,nboton[numero].nombre,modo);	
}

void PaintBotones()
{
 int x;
	for(x=0;x<MAXBOTONES && nboton[x].numero!=-1 ;x++)PaintBoton(x,0);
}	

int DetecBotones(int x, int y)
{
int z;
	for(z=0;z<MAXBOTONES && nboton[z].numero!=-1 ;z++)
	{
		if(x>nboton[z].x && y>nboton[z].y && x<(nboton[z].x+nboton[z].w) && y<(nboton[z].y+nboton[z].h))
			return z;
	}
return -1;

}

void Inibotones()
{
     nboton[0].numero=1;
	nboton[0].nombre="1 S";
	nboton[0].x=10;
	nboton[0].y=370;
	nboton[0].w=89;
	nboton[0].h=25;

	nboton[1].numero=1;
	nboton[1].nombre=".5 S";
	nboton[1].x=10;
	nboton[1].y=400;
	nboton[1].w=89;
	nboton[1].h=25;
	
	nboton[2].numero=1;
	nboton[2].nombre=".3 S";
	nboton[2].x=10;
	nboton[2].y=430;
	nboton[2].w=89;
	nboton[2].h=25;
	
	nboton[3].numero=-1;
     
/*
     
	nboton[0].numero=1;
	nboton[0].nombre="An0";
	nboton[0].x=10;
	nboton[0].y=10;
	nboton[0].w=89;

	nboton[0].h=25;

	nboton[1].numero=1;
	nboton[1].nombre="An1";
	nboton[1].x=10;
	nboton[1].y=40;
	nboton[1].w=89;
	nboton[1].h=25;

	nboton[2].numero=1;
	nboton[2].nombre="An2";
	nboton[2].x=10;
	nboton[2].y=70;
	nboton[2].w=89;
	nboton[2].h=25;

	nboton[3].numero=1;
	nboton[3].nombre="An3";
	nboton[3].x=10;
	nboton[3].y=100;
	nboton[3].w=89;
	nboton[3].h=25;

	nboton[4].numero=1;
	nboton[4].nombre="An4";
	nboton[4].x=10;
	nboton[4].y=130;
	nboton[4].w=89;
	nboton[4].h=25;

	nboton[5].numero=1;
	nboton[5].nombre="An5";
	nboton[5].x=10;
	nboton[5].y=160;
	nboton[5].w=89;
	nboton[5].h=25;

	nboton[6].numero=1;
	nboton[6].nombre="Dig13";
	nboton[6].x=460;
	nboton[6].y=10;
	nboton[6].w=89;
	nboton[6].h=25;

	nboton[7].numero=1;
	nboton[7].nombre="Dig12";
	nboton[7].x=460;
	nboton[7].y=40;
	nboton[7].w=89;
	nboton[7].h=25;

	nboton[8].numero=1;
	nboton[8].nombre="Dig11";
	nboton[8].x=460;
	nboton[8].y=70;
	nboton[8].w=89;
	nboton[8].h=25;

	nboton[9].numero=1;
	nboton[9].nombre="Dig10";
	nboton[9].x=460;
	nboton[9].y=100;
	nboton[9].w=89;
	nboton[9].h=25;

	nboton[10].numero=1;
	nboton[10].nombre="Dig9";
	nboton[10].x=460;
	nboton[10].y=130;
	nboton[10].w=89;
	nboton[10].h=25;

	nboton[11].numero=1;
	nboton[11].nombre="Dig8";
	nboton[11].x=460;
	nboton[11].y=160;
	nboton[11].w=89;
	nboton[11].h=25;

	nboton[12].numero=1;
	nboton[12].nombre="Dig7";
	nboton[12].x=460;
	nboton[12].y=190;
	nboton[12].w=89;
	nboton[12].h=25;

	nboton[13].numero=1;
	nboton[13].nombre="Dig6";
	nboton[13].x=460;
	nboton[13].y=220;
	nboton[13].w=89;
	nboton[13].h=25;

	nboton[14].numero=1;
	nboton[14].nombre="Dig5";
	nboton[14].x=460;
	nboton[14].y=250;
	nboton[14].w=89;
	nboton[14].h=25;

	nboton[15].numero=1;
	nboton[15].nombre="Dig4";
	nboton[15].x=460;
	nboton[15].y=280;
	nboton[15].w=89;
	nboton[15].h=25;

	nboton[16].numero=1;
	nboton[16].nombre="Dig3";
	nboton[16].x=460;
	nboton[16].y=310;
	nboton[16].w=89;
	nboton[16].h=25;

	nboton[17].numero=1;
	nboton[17].nombre="Dig2";
	nboton[17].x=460;
	nboton[17].y=340;
	nboton[17].w=89;
	nboton[17].h=25;
*/
	nboton[18].numero=-1;
}



void PaintLight(int x,int y,int w,int h,char *texto,unsigned char tipo,int clase)
{
 SDL_Rect clip[ 1 ];
 SDL_Surface *message;
   if(tipo==0)
	{
		clip[ 0 ].x = 0;
    	clip[ 0 ].y = 25;
    	clip[ 0 ].w = 89;
    	clip[ 0 ].h = 25;	
	}
	else
	{
		if(clase==2)
		   {
			clip[ 0 ].x = 89;
    		clip[ 0 ].y = 25;
    		clip[ 0 ].w = 89;
    		clip[ 0 ].h = 25;			
		   }

		if(clase==3)
		   {
			clip[ 0 ].x = 0;
    		clip[ 0 ].y = 75;
    		clip[ 0 ].w = 89;
    		clip[ 0 ].h = 25;			
		   }
	
	}
	apply_surfaceB( x, y, dots, screen, &clip[ 0 ] );
	message = TTF_RenderText_Solid( font,texto, textColor );
	apply_surface( x+28, y+2, message, screen );
}

void PaintLuz(int numero,int modo)
{
	PaintLight(nluz[numero].x,nluz[numero].y,nluz[numero].w,nluz[numero].h,nluz[numero].nombre,modo,nluz[numero].numero);
}

void PaintLuces()
{
	int x;
	for(x=0;x<MAXLUCES && nluz[x].numero!=-1 ;x++)
	{
		if(nluz[x].estado==0)
			PaintLuz(x,0);
		 else
			PaintLuz(x,1);
	}
}	

void IniLuces()
{
	nluz[0].numero=3;
	nluz[0].nombre="An0";
	nluz[0].estado=0;
	nluz[0].x=50;
	nluz[0].y=10;
	nluz[0].w=89;
	nluz[0].h=25;

	nluz[1].numero=3;
	nluz[1].nombre="An1";
	nluz[1].estado=0;
	nluz[1].x=50;
	nluz[1].y=40;
	nluz[1].w=89;
	nluz[1].h=25;

	nluz[2].numero=3;
	nluz[2].nombre="An2";
	nluz[2].estado=0;
	nluz[2].x=50;
	nluz[2].y=70;
	nluz[2].w=89;
	nluz[2].h=25;

	nluz[3].numero=3;
	nluz[3].nombre="An3";
	nluz[3].estado=0;	
	nluz[3].x=50;
	nluz[3].y=100;
	nluz[3].w=89;
	nluz[3].h=25;

	nluz[4].numero=3;
	nluz[4].nombre="An4";
	nluz[4].estado=0;	
	nluz[4].x=50;
	nluz[4].y=130;
	nluz[4].w=89;
	nluz[4].h=25;

	nluz[5].numero=3;
	nluz[5].nombre="An5";
	nluz[5].estado=0;	
	nluz[5].x=50;
	nluz[5].y=160;
	nluz[5].w=89;
	nluz[5].h=25;

	nluz[6].numero=3;
	nluz[6].nombre="Dig13";
	nluz[6].estado=0;
	nluz[6].x=500;
	nluz[6].y=10;
	nluz[6].w=89;
	nluz[6].h=25;

	nluz[7].numero=3;
	nluz[7].nombre="Dig12";
	nluz[7].estado=0;
	nluz[7].x=500;
	nluz[7].y=40;
	nluz[7].w=89;
	nluz[7].h=25;

	nluz[8].numero=3;
	nluz[8].nombre="Dig11";
	nluz[8].estado=0;
	nluz[8].x=500;
	nluz[8].y=70;
	nluz[8].w=89;
	nluz[8].h=25;

	nluz[9].numero=3;
	nluz[9].nombre="Dig10";
	nluz[9].estado=0;
	nluz[9].x=500;
	nluz[9].y=100;
	nluz[9].w=89;
	nluz[9].h=25;

	nluz[10].numero=3;
	nluz[10].nombre="Dig9";
	nluz[10].estado=0;
	nluz[10].x=500;
	nluz[10].y=130;
	nluz[10].w=89;
	nluz[10].h=25;

	nluz[11].numero=3;
	nluz[11].nombre="Dig8";
	nluz[11].estado=0;
	nluz[11].x=500;
	nluz[11].y=160;
	nluz[11].w=89;
	nluz[11].h=25;

	nluz[12].numero=3;
	nluz[12].nombre="Dig7";
	nluz[12].estado=0;
	nluz[12].x=500;
	nluz[12].y=190;
	nluz[12].w=89;
	nluz[12].h=25;

	nluz[13].numero=3;
	nluz[13].nombre="Dig6";
	nluz[13].estado=0;
	nluz[13].x=500;
	nluz[13].y=220;
	nluz[13].w=89;
	nluz[13].h=25;

	nluz[14].numero=3;
	nluz[14].nombre="Dig5";
	nluz[14].estado=0;
	nluz[14].x=500;
	nluz[14].y=250;
	nluz[14].w=89;
	nluz[14].h=25;

	nluz[15].numero=3;
	nluz[15].nombre="Dig4";
	nluz[15].estado=0;
	nluz[15].x=500;
	nluz[15].y=280;
	nluz[15].w=89;
	nluz[15].h=25;

	nluz[16].numero=3;
	nluz[16].nombre="Dig3";
	nluz[16].estado=0;
	nluz[16].x=500;
	nluz[16].y=310;
	nluz[16].w=89;
	nluz[16].h=25;

	nluz[17].numero=3;
	nluz[17].nombre="Dig2";
	nluz[17].estado=0;
	nluz[17].x=500;
	nluz[17].y=340;
	nluz[17].w=89;
	nluz[17].h=25;

	nluz[18].numero=-1;
}	

#if YesWindows  
int WriteSerie(HANDLE hSerial,char *c,int tamano)
{
 int bRes;
 DWORD dwError, dwNumBytesWritten=0;
              bRes=WriteFile(hSerial,c,tamano,&dwNumBytesWritten,NULL );
              if (!bRes) printf("Error mandado Bytes %u   \n",dwNumBytesWritten);	    
}


int ReadSerie(HANDLE hSerial,char *c,int tamano)
{
 int bRes;
 DWORD dwError, bytesRead=0;
              bRes=ReadFile(hSerial,c,tamano,&bytesRead,NULL );
              if (!bRes)
              {
                printf("Error leyendo Bytes %u \n",bytesRead);	
                return -1;
              }
              if(bytesRead==0) return -2;                               
}

#endif




void Inientradas()
{
	nentrada[0].numero=4;
	nentrada[0].nombre="PORTB";
	nentrada[0].x=10;
	nentrada[0].y=210;
	nentrada[0].w=120;
	nentrada[0].h=25;

	nentrada[1].numero=1;
	nentrada[1].nombre="PORTC";
	nentrada[1].x=10;
	nentrada[1].y=240;
	nentrada[1].w=120;
	nentrada[1].h=25;

	nentrada[2].numero=1;
	nentrada[2].nombre="PORTD";
	nentrada[2].x=10;
	nentrada[2].y=270;
	nentrada[2].w=120;
	nentrada[2].h=25;
	
	nentrada[3].numero=1;
	nentrada[3].nombre="2000";
	nentrada[3].x=10;
	nentrada[3].y=340;
	nentrada[3].w=120;
	nentrada[3].h=25;

	nentrada[4].numero=-1;
}

void PaintInput(int x,int y,int w,int h,char *texto,unsigned char tipo)
{
 SDL_Rect clip;
 SDL_Surface *message;
		clip.x = x;
    	clip.y = y;
    	clip.w = w;
    	clip.h = h;	

	SDL_FillRect( screen, &clip, SDL_MapRGB( screen->format, 0xFF, 0xFF, 0xFF ) );
	message = TTF_RenderText_Solid( font,texto, textColor );
	apply_surface( x+2, y+2, message, screen );
}


void PaintEntrada(int numero,int modo)
{
	PaintInput(nentrada[numero].x,nentrada[numero].y,nentrada[numero].w,nentrada[numero].h,nentrada[numero].nombre,modo);
}


void PaintEntradas()
{
 int x;
	for(x=0;x<MAXENTRADAS && nentrada[x].numero!=-1 ;x++)
	{
			PaintEntrada(x,0);
	}
}	

void TextEntrada(int numero,char *s)
{
	PaintInput(nentrada[numero].x,nentrada[numero].y,nentrada[numero].w,nentrada[numero].h,s,0);
}	

void ProcesoEntradas()
{
static unsigned char vportb,vportc,vportd,z;
	int zz;

	if(!strncmp(VARI,"PORTB=",5))
		{
			strncpy(Binput2,VARI+6,5);
			sprintf(VARI,"PORTB=%s",Binput2);
			TextEntrada(0,VARI);
			z=vportb;
			vportb=atoi(Binput2);
			if(SONIDO)if(z!=vportb)zz = Mix_PlayChannel(-1, sonido, 0);
			if(DEBUG)printf("-portb=%d\n",vportb);
			if(vportb & 1)
				nluz[11].estado=1;
			  else
				nluz[11].estado=0;
			if(vportb & 2)
				nluz[10].estado=1;
			  else
				nluz[10].estado=0;
			if(vportb & 4)
				nluz[9].estado=1;
			  else
				nluz[9].estado=0;
			if(vportb & 8)
				nluz[8].estado=1;
			  else
				nluz[8].estado=0;
			if(vportb & 16)
				nluz[7].estado=1;
			  else
				nluz[7].estado=0;
			if(vportb & 32)
				nluz[6].estado=1;
			  else
				nluz[6].estado=0;			
		}
	if(!strncmp(VARI,"PORTC=",5)) 
		{
			strncpy(Binput2,VARI+6,5);
			sprintf(VARI,"PORTC=%s",Binput2);
			TextEntrada(1,VARI);
			z=vportc;
			vportc=atoi(Binput2);
			if(SONIDO)if(z!=vportc)z = Mix_PlayChannel(-1, sonido, 0);
			if(DEBUG)printf("-portc=%d\n",vportc);
			if(vportc & 1)
				nluz[0].estado=1;
			  else
				nluz[0].estado=0;
			if(vportc & 2)
				nluz[1].estado=1;
			  else
				nluz[1].estado=0;
			if(vportc & 4)
				nluz[2].estado=1;
			  else
				nluz[2].estado=0;
			if(vportc & 8)
				nluz[3].estado=1;
			  else
				nluz[3].estado=0;
			if(vportc & 16)
				nluz[4].estado=1;
			  else
				nluz[4].estado=0;
			if(vportc & 32)
				nluz[5].estado=1;
			  else
				nluz[5].estado=0;	
		}
	if(!strncmp(VARI,"PORTD=",5))
		{
			strncpy(Binput2,VARI+6,5);
			sprintf(VARI,"PORTD=%s",Binput2);
			TextEntrada(2,VARI);
			z=vportd;
			vportd=atoi(Binput2);
			if(SONIDO)if(z!=vportd)z = Mix_PlayChannel(-1, sonido, 0);
			if(DEBUG)printf("-portd=%d\n",vportd);
			if(vportd & 128)
				nluz[12].estado=1;
			  else
				nluz[12].estado=0;
			if(vportd & 64)
				nluz[13].estado=1;
			  else
				nluz[13].estado=0;
			if(vportd & 32)
				nluz[14].estado=1;
			  else
				nluz[14].estado=0;
			if(vportd & 16)
				nluz[15].estado=1;
			  else
				nluz[15].estado=0;
			if(vportd & 8)
				nluz[16].estado=1;
			  else
				nluz[16].estado=0;
			if(vportd & 4)
				nluz[17].estado=1;
			  else
				nluz[17].estado=0;
			
		}
//	printf("portb=%d portc=%d portd=%d\n",vportb,vportc,vportd);
	PaintLuces();
	SDL_Flip( screen );
}	

int main(int argc, char *argv[])
{
  
 	int mouse_x,mouse_y;
	int zboton=0;	
    int quit = 0;
    Uint8 *teclas; 
	int nbytes;
	int canal;
    
#if YesWindows 
	freopen("CON", "w", stdout); // redirects stdout
	freopen("CON", "w", stderr); // redirects stderr
#endif

    printf("%s\n",argv[0]);
	if(argc==2)
		{
		 printf("%s\n",argv[1]);
 	 	 MODEMDEVICE=argv[1];
		}
	 else
		{
		 MODEMDEVICE=MODEMDEVICEdefault;
		}
	printf("Controlador Arduino mediante interfaz ");

	printf(MODEMDEVICE);
	printf("\n");
	Inirs232();


	Inibotones();
	IniLuces ();
	Inientradas();

    if( init() == 0 ) return 1;
    if( load_files() == 0 ) return 2;

	apply_surface( 0, 0, background, screen );
    message = TTF_RenderText_Solid( font, "ARDUINO", textColor );
	apply_surface( 270, 1, message, screen );

	PaintBotones();
	PaintLuces();
	PaintEntradas ();
    if( SDL_Flip( screen ) == -1 ) return 3;

#if YesWindows 
      SDL_Delay(100);
     printf("MODO WINDOWS\n");
     PurgeComm(hSerial,PURGE_RXCLEAR | PURGE_TXCLEAR); 
     SDL_Delay(1500);
 	WriteSerie(hSerial,"NOAUTO\n",5); 
#else
     printf("MODO LINUX\n");
	write(fd,"\n",1);
 	write(fd,"NOAUTO",5);
// 	write(fd,"\n",1); 
	while(( nbytes = read(fd, Binput2, 1)>0 )); //Vacia buffer
#endif
	canal = Mix_PlayChannel(-1, sonido, 0);
    ContadorI=0;		
    while( quit == 0 )
    {	
		SDL_Delay(100);
#if YesWindows
         while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else		
		 while(( nbytes = read(fd, Binput2, 1)>0 ))
#endif		
		{
//		 printf("Leidos %d -> %s\n",nbytes,Binput2);	
		 Binput[ContadorI]=Binput2[0];
		 ContadorI++;
	  	 if (Binput2[0] == '\n')
           {
			if(ContadorI<2)ContadorI=2;   
          	Binput[ContadorI-2]=0;
		  	ContadorI=0;	
  			if(DEBUG)printf("Leidos-> %s\n",Binput);
			sprintf(VARI,"%s",Binput);
			ProcesoEntradas();
       	   } 
		}
     	if(!TimeLeft())
	                {
	                 if(DEBUG)printf("LECTURA DE PUERTOS\n");
#if YesWindows						
	                 WriteSerie(hSerial,"IPORTB\n",7);
	                 WriteSerie(hSerial,"IPORTC\n",7);
	                 WriteSerie(hSerial,"IPORTD\n",7);
#else
			write(fd,"IPORTB\n",7);
			write(fd,"IPORTC\n",7);
	                write(fd,"IPORTD\n",7);
#endif							
                    }
        while( SDL_PollEvent( &event ) )
        {
			teclas = SDL_GetKeyState(NULL);
			if(teclas[SDLK_ESCAPE] ) quit = 1;
            if( event.type == SDL_QUIT )   quit = 1;
            if( event.type == SDL_KEYDOWN ) 
			{
				if(DEBUG)printf("Evento Tecla\n");				
			}
			if( event.type == SDL_MOUSEBUTTONDOWN ) {
				mouse_x=event.button.x;
				mouse_y=event.button.y;
				zboton=DetecBotones(mouse_x,mouse_y);
				if(zboton!=-1)
					{                            
 /*                             
					 if(nluz[zboton].estado==0)
						{
							nluz[zboton].estado=1;
							sprintf(VARI,"1%s",nluz[zboton].nombre);
						}
		 				else
						{
							nluz[zboton].estado=0;
							sprintf(VARI,"0%s",nluz[zboton].nombre);
						}
*/
                 switch (zboton)
                        {                         
                         case 0:
                           TICK_INTERVAL=1000;
                           TextEntrada(3,"1000 mS");  
                         break;                               
                         case 1:
                            TICK_INTERVAL=500; 
                            TextEntrada(3,"500 mS"); 
                         break;                               
                         case 2:
                            TICK_INTERVAL=300;  
                            TextEntrada(3,"300 mS");
                         break;                                                                                              
                         default:
                         printf("No_Boton\n");               
                        }
               
						
/*                     printf("%s\n",VARI);
#if YesWindows                     
                     WriteSerie(hSerial,VARI,7);
                     WriteSerie(hSerial,"\n",1);
#else
                     write(fd,VARI,7);
                     write(fd,"\n",1);             							
#endif  
*/                   
					 PaintBoton(zboton,1);
					}

					if(DEBUG)printf("Evento Raton X=%d Y=%d Boton=%d\n",mouse_x,mouse_y,zboton);					
					if( SDL_Flip( screen ) == -1 ) return 3;
			}
			if( event.type == SDL_MOUSEBUTTONUP ) {
				if(zboton!=-1){
					PaintBotones();
					PaintLuces();
					if(DEBUG)printf("RepintarBoton %d\n",zboton);
					zboton=-1;					
				}
					
				if( SDL_Flip( screen ) == -1 ) return 3;
			}
	
        }
    }
 
 
     //Free the surface and quit SDL
    clean_up();
#if YesWindows    
    CloseHandle(hSerial);
#else    
	close(fd);
#endif

    return 0;
   
}
 
